# image acquisition
import subprocess
from datetime import datetime
import RPi.GPIO as GPIO
import os
import errno


def take_hologram(path, preview_time=2000, shutter_time=150000):
    # initialize GPIO
    GPIO.setmode(GPIO.BCM)
    GPIO.setup(26, GPIO.OUT)

    width = 3280
    height = 2464
    dirname = "%s/" % datetime.now().strftime("%H-%M-%S_%d-%m-%Y")
    name = "hologram.jpg"
    if not os.path.exists(os.path.dirname(path + dirname)):
        try:
            os.makedirs(os.path.dirname(path + dirname))
        except OSError as exc:  # Guard against race condition
            if exc.errno != errno.EEXIST:
                raise

    holopath = path + dirname + name
    cmd = "raspistill -t %d --mode 2 --raw -awb off -awbg 1,3 --shutter %d -ISO 100 -w %s -h %s -o " % (
        preview_time, shutter_time, width, height) + holopath
    print(cmd)

    # turn on LED
    GPIO.output(26, GPIO.HIGH)
    # capture images
    subprocess.run(cmd, shell=True)
    # turn off LED
    GPIO.output(26, GPIO.LOW)

    return holopath
